#ifndef __CAAlign_H_
#define __CAAlign_H_

#include "alignapp.h"
#include "smallapp.h"

class calign:public alignapp
{
private:
	int	top;
	int     hash_ban; 
	int     coverthresh;
	int	seq_sym;
	int     num_seq, *len_seq, totseq;
	char    **src_name;
	char    **src_seq;
	int	**src_qual;
	char    *index;
	int     *pos;
	int	*seq2clust;
	double	*seq2clustdiff;
	int     *num_pref, *num_suf;
	int     *kmerseq, kmerpos;
	char    **prefseq, **sufseq;
	char    **Conseq;
	int	*mem_Conseq;
	int     *len_prefseq, *len_sufseq;
	double  cov;
	double	P;
	char    *tmpseq;
	SMALLTABLE **hash_table;
	int     *len_Conseq;
	int	*con_sort;
	int	*con2sort;
	int	ifrefine;
	int	max_seqlen;
	int	speedup;
	int	seqnum_limit;
	int	start_idx;
	int	unassigned_tot;
	int	unassigned_valid;
	int	*unassigned_idx;

	char	fileprefix[1000];

public:
	~calign(void) { cleanup(); }
	void 	ca2otu(void);
	void 	ca2otu(int smallclust);
	void	ini_calign(int, int);
	void	copyreads(int, int *, char**, char**, int*);
	void    getreads(int tot, char **seq, char **name, int* len);
	void	getreads(char *seqfile);
	void	getreads(char *seqfile, int minlen);
	int	readseq(char **seq, int *len_seq, char **src_name, FILE *fp, int minlen);
	void	getqual(char *qualityfile);
	void	iteralign(void);
	void	greedyrecruit(void);
	char*	oneconsensus(int &len);
	char*	pickconsensus(int &conseqlen, int &seqi); //pick longest unassigned sequence as consensus
	int	getconsensus(int num_cover, long *ctl, char *conseq); //consensus by consensus alignment
	void 	map2consensus(int &conseqlen, char *conseq, int& assignedtot, int *assignedseq, double *assignedcov);
	int	prefsufseq(int num_cover, long int* ctl, char **src_seq, int *len_seq, int num_seq, char *index,
		char **prefseq, int *len_prefseq, char **sufseq, int *len_sufseq, int *kmerseq, int *kmerpos);
	void	cleanup(void);
	void	removesmall(int small_clust_size, bool ifempty);

	void	saveresults(char *outfile0);
	char*   int2seq(char *src_seq, int len_seq);
	char*   seq2int(char *src_seq, int len_seq);
	void    writeseq(char *src_seq, char *src_name, int len_seq, FILE *fp);
	void	printaln(char *seq1, int len1, char *seq2, int len2, vector<int> aln);
	void    writesingleton(void);
	void    writeconseq(void);
	void    writeclust(void);
	void    writeclustsize(void);

	void	assignseq(int num_con, int tot, int *assignedseq, double *assignedcov);
	void	getunassigned(int ifreshuffle);
	int	hashcover(char **src_seq, int *len_seq, int num_seq, char *index, int *num_cover_list, long **ctl_list);
	void    OneHash(SMALLTABLE **hash_table, char *src_seq, int len_seq);
	void    OneSeqHash(SMALLTABLE **hash_table, char *src_seq, int len_seq);
	void	diffstat(int num0, int id, int *diff2id, double *diff, int &min_i, int &max_i, int &median_i);
	void	sortcons(void);

	int     align2intseq(char *seq1, int len1, char *seq2, int len2, int &alnlen);
	int     align2charseq(char *seq1, char *seq2);

	//functions for subotu
	int     getclustsize(int clust);
	int     getclustnum(void);
	int     getclustinfo(int clust, int *mem, double *diff, char *conseq);
	void    subotu(int minclustsize, char *fileprefix);
};

#endif
